<?php
/**
 * OrderDeliveryFillableProperties
 *
 * PHP version 5
 *
 * @category Class
 * @package  Ensi\OmsClient
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * OMS
 *
 * Управление заказами
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: mail@greensight.ru
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 4.3.1
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace Ensi\OmsClient\Dto;

use \ArrayAccess;
use \Ensi\OmsClient\ObjectSerializer;

/**
 * OrderDeliveryFillableProperties Class Doc Comment
 *
 * @category Class
 * @package  Ensi\OmsClient
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */
class OrderDeliveryFillableProperties implements ModelInterface, ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $openAPIModelName = 'OrderDeliveryFillableProperties';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPITypes = [
        'delivery_service' => 'int',
        'delivery_method' => 'int',
        'delivery_cost' => 'int',
        'delivery_price' => 'int',
        'delivery_tariff_id' => 'int',
        'delivery_point_id' => 'int',
        'delivery_address' => '\Ensi\OmsClient\Dto\Address',
        'delivery_comment' => 'string'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPIFormats = [
        'delivery_service' => null,
        'delivery_method' => null,
        'delivery_cost' => null,
        'delivery_price' => null,
        'delivery_tariff_id' => null,
        'delivery_point_id' => null,
        'delivery_address' => null,
        'delivery_comment' => null
    ];

    /**
      * Array of nullable properties. Used for (de)serialization
      *
      * @var boolean[]
      */
    protected static $openAPINullables = [
        'delivery_service' => false,
        'delivery_method' => false,
        'delivery_cost' => false,
        'delivery_price' => false,
        'delivery_tariff_id' => true,
        'delivery_point_id' => true,
        'delivery_address' => true,
        'delivery_comment' => true
    ];

    /**
      * If a nullable field gets set to null, insert it here
      *
      * @var boolean[]
      */
    protected $openAPINullablesSetToNull = [];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPITypes()
    {
        return self::$openAPITypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPIFormats()
    {
        return self::$openAPIFormats;
    }

        /**
     * Array of property to nullable mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPINullables()
    {
        return self::$openAPINullables;
    }

    /**
     * Array of nullable field names deliberately set to null
     *
     * @return array
     */
    public function getOpenAPINullablesSetToNull()
    {
        return $this->openAPINullablesSetToNull;
    }

    public function setOpenAPINullablesSetToNull($nullablesSetToNull)
    {
        $this->openAPINullablesSetToNull=$nullablesSetToNull;
        return $this;
    }

    /**
     * Checks if a property is nullable
     *
     * @return bool
     */
    public static function isNullable(string $property): bool
    {
        if (isset(self::$openAPINullables[$property])) {
            return self::$openAPINullables[$property];
        }

        return false;
    }

    /**
     * Checks if a nullable property is set to null.
     *
     * @return bool
     */
    public function isNullableSetToNull(string $property): bool
    {
        if (in_array($property, $this->getOpenAPINullablesSetToNull())) {
            return true;
        }
        return false;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'delivery_service' => 'delivery_service',
        'delivery_method' => 'delivery_method',
        'delivery_cost' => 'delivery_cost',
        'delivery_price' => 'delivery_price',
        'delivery_tariff_id' => 'delivery_tariff_id',
        'delivery_point_id' => 'delivery_point_id',
        'delivery_address' => 'delivery_address',
        'delivery_comment' => 'delivery_comment'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'delivery_service' => 'setDeliveryService',
        'delivery_method' => 'setDeliveryMethod',
        'delivery_cost' => 'setDeliveryCost',
        'delivery_price' => 'setDeliveryPrice',
        'delivery_tariff_id' => 'setDeliveryTariffId',
        'delivery_point_id' => 'setDeliveryPointId',
        'delivery_address' => 'setDeliveryAddress',
        'delivery_comment' => 'setDeliveryComment'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'delivery_service' => 'getDeliveryService',
        'delivery_method' => 'getDeliveryMethod',
        'delivery_cost' => 'getDeliveryCost',
        'delivery_price' => 'getDeliveryPrice',
        'delivery_tariff_id' => 'getDeliveryTariffId',
        'delivery_point_id' => 'getDeliveryPointId',
        'delivery_address' => 'getDeliveryAddress',
        'delivery_comment' => 'getDeliveryComment'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$openAPIModelName;
    }

    

    

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->setIfExists('delivery_service', $data, null);
        $this->setIfExists('delivery_method', $data, null);
        $this->setIfExists('delivery_cost', $data, null);
        $this->setIfExists('delivery_price', $data, null);
        $this->setIfExists('delivery_tariff_id', $data, null);
        $this->setIfExists('delivery_point_id', $data, null);
        $this->setIfExists('delivery_address', $data, null);
        $this->setIfExists('delivery_comment', $data, null);
    }

    public function setIfExists(string $variableName, $fields, $defaultValue)
    {
        if (is_array($fields) && array_key_exists($variableName, $fields) && is_null($fields[$variableName]) && self::isNullable($variableName)) {
            array_push($this->openAPINullablesSetToNull, $variableName);
        }

        $this->container[$variableName] = isset($fields[$variableName]) ? $fields[$variableName] : $defaultValue;

        return $this;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets delivery_service
     *
     * @return int|null
     */
    public function getDeliveryService()
    {
        return $this->container['delivery_service'];
    }

    /**
     * Sets delivery_service
     *
     * @param int|null $delivery_service служба доставки
     *
     * @return $this
     */
    public function setDeliveryService($delivery_service)
    {


        /*if (is_null($delivery_service)) {
            throw new \InvalidArgumentException('non-nullable delivery_service cannot be null');
        }*/
        $this->container['delivery_service'] = $delivery_service;

        return $this;
    }

    /**
     * Gets delivery_method
     *
     * @return int|null
     */
    public function getDeliveryMethod()
    {
        return $this->container['delivery_method'];
    }

    /**
     * Sets delivery_method
     *
     * @param int|null $delivery_method метод доставки
     *
     * @return $this
     */
    public function setDeliveryMethod($delivery_method)
    {


        /*if (is_null($delivery_method)) {
            throw new \InvalidArgumentException('non-nullable delivery_method cannot be null');
        }*/
        $this->container['delivery_method'] = $delivery_method;

        return $this;
    }

    /**
     * Gets delivery_cost
     *
     * @return int|null
     */
    public function getDeliveryCost()
    {
        return $this->container['delivery_cost'];
    }

    /**
     * Sets delivery_cost
     *
     * @param int|null $delivery_cost стоимость доставки (без учета скидки) в копейках
     *
     * @return $this
     */
    public function setDeliveryCost($delivery_cost)
    {


        /*if (is_null($delivery_cost)) {
            throw new \InvalidArgumentException('non-nullable delivery_cost cannot be null');
        }*/
        $this->container['delivery_cost'] = $delivery_cost;

        return $this;
    }

    /**
     * Gets delivery_price
     *
     * @return int|null
     */
    public function getDeliveryPrice()
    {
        return $this->container['delivery_price'];
    }

    /**
     * Sets delivery_price
     *
     * @param int|null $delivery_price стоимость доставки (с учетом скидки) в копейках
     *
     * @return $this
     */
    public function setDeliveryPrice($delivery_price)
    {


        /*if (is_null($delivery_price)) {
            throw new \InvalidArgumentException('non-nullable delivery_price cannot be null');
        }*/
        $this->container['delivery_price'] = $delivery_price;

        return $this;
    }

    /**
     * Gets delivery_tariff_id
     *
     * @return int|null
     */
    public function getDeliveryTariffId()
    {
        return $this->container['delivery_tariff_id'];
    }

    /**
     * Sets delivery_tariff_id
     *
     * @param int|null $delivery_tariff_id ID тарифа на доставку из сервиса логистики
     *
     * @return $this
     */
    public function setDeliveryTariffId($delivery_tariff_id)
    {

        if (is_null($delivery_tariff_id)) {
            array_push($this->openAPINullablesSetToNull, 'delivery_tariff_id');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('delivery_tariff_id', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['delivery_tariff_id'] = $delivery_tariff_id;

        return $this;
    }

    /**
     * Gets delivery_point_id
     *
     * @return int|null
     */
    public function getDeliveryPointId()
    {
        return $this->container['delivery_point_id'];
    }

    /**
     * Sets delivery_point_id
     *
     * @param int|null $delivery_point_id ID пункта самовывоза из сервиса логистики
     *
     * @return $this
     */
    public function setDeliveryPointId($delivery_point_id)
    {

        if (is_null($delivery_point_id)) {
            array_push($this->openAPINullablesSetToNull, 'delivery_point_id');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('delivery_point_id', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['delivery_point_id'] = $delivery_point_id;

        return $this;
    }

    /**
     * Gets delivery_address
     *
     * @return \Ensi\OmsClient\Dto\Address|null
     */
    public function getDeliveryAddress()
    {
        return $this->container['delivery_address'];
    }

    /**
     * Sets delivery_address
     *
     * @param \Ensi\OmsClient\Dto\Address|null $delivery_address delivery_address
     *
     * @return $this
     */
    public function setDeliveryAddress($delivery_address)
    {

        if (is_null($delivery_address)) {
            array_push($this->openAPINullablesSetToNull, 'delivery_address');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('delivery_address', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['delivery_address'] = $delivery_address;

        return $this;
    }

    /**
     * Gets delivery_comment
     *
     * @return string|null
     */
    public function getDeliveryComment()
    {
        return $this->container['delivery_comment'];
    }

    /**
     * Sets delivery_comment
     *
     * @param string|null $delivery_comment комментарий к доставке
     *
     * @return $this
     */
    public function setDeliveryComment($delivery_comment)
    {

        if (is_null($delivery_comment)) {
            array_push($this->openAPINullablesSetToNull, 'delivery_comment');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('delivery_comment', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['delivery_comment'] = $delivery_comment;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     *
     * @param integer $offset Offset
     * @param mixed   $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        return json_encode(
            ObjectSerializer::sanitizeForSerialization($this),
            JSON_PRETTY_PRINT
        );
    }

    /**
     * Gets a header-safe presentation of the object
     *
     * @return string
     */
    public function toHeaderValue()
    {
        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


